/*
Copyright 2012 Embedded Data Systems, LLC

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

import java.io.BufferedWriter;
import java.util.concurrent.LinkedBlockingQueue;
import java.io.File;
import java.io.FileWriter;
import javax.swing.JFileChooser;
import java.net.*;
import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Date;
import java.util.Enumeration;
import java.util.Timer;
import java.util.TimerTask;


public class Post_Server extends javax.swing.JFrame {
	private static final long serialVersionUID = 1L;
	private String FileName;
	private ServerSocket sSocket;
	private Timer timer;
	private LinkedBlockingQueue<String> printQueue;

	/** Creates new form Post_Server */
	public Post_Server() {
		initComponents();
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        lblTitle = new javax.swing.JLabel();
        tfLogFile = new javax.swing.JTextField();
        lblLogFile = new javax.swing.JLabel();
        btnLogFile = new javax.swing.JButton();
        btnQuit = new javax.swing.JButton();
        btnBegin = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        message = new javax.swing.JTextArea();
        tfPort = new javax.swing.JTextField();
        lblPort = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("EDS Post Server - v1.00");

        lblTitle.setText("Accepts post data from EDS products");

        tfLogFile.setEditable(false);

        lblLogFile.setText("Log File");

        btnLogFile.setText("Select Log File");
        btnLogFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLogFileActionPerformed(evt);
            }
        });

        btnQuit.setText("Quit");
        btnQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnQuitActionPerformed(evt);
            }
        });

        btnBegin.setText("Begin");
        btnBegin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBeginActionPerformed(evt);
            }
        });

        message.setColumns(20);
        message.setRows(5);
        jScrollPane1.setViewportView(message);

        tfPort.setText("8080");

        lblPort.setText("Port");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 612, Short.MAX_VALUE)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(lblLogFile)
                            .add(lblPort))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(btnLogFile)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnBegin)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 260, Short.MAX_VALUE)
                                .add(btnQuit))
                            .add(tfLogFile, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 553, Short.MAX_VALUE)
                            .add(tfPort, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 88, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(lblTitle))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(lblTitle)
                .add(27, 27, 27)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tfPort, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(lblPort))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tfLogFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(lblLogFile))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnLogFile)
                    .add(btnQuit)
                    .add(btnBegin))
                .add(18, 18, 18)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 453, Short.MAX_VALUE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

	private void btnQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnQuitActionPerformed
		try {
			sSocket.close();
		}
		catch(Exception ex) {

		}
		setVisible(false);
		dispose();
		System.exit(0);
	}//GEN-LAST:event_btnQuitActionPerformed

	private void btnBeginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBeginActionPerformed
		try {
			printMessage("Network Interfaces", false);
			printMessage("------------------", false);
			Enumeration<NetworkInterface> nets = NetworkInterface.getNetworkInterfaces();
			for (NetworkInterface netint : Collections.list(nets)) {
				printMessage("Name: " + netint.getDisplayName() + " (" + netint.getName() + ")", false);
				Enumeration<InetAddress> inetAddresses = netint.getInetAddresses();
				for (InetAddress inetAddress : Collections.list(inetAddresses)) {
					printMessage("InetAddress: " + inetAddress, false);
				}
				printMessage("", false);
			}

			// Convert port to int to check if valid, will throw exception if not
			int port = Integer.parseInt(tfPort.getText());
			printMessage("Listening on port " + port + "...", true);

			// Create a queue for printing messages to the GUI
			printQueue = new LinkedBlockingQueue<String>();

			// Create the queue for the receiver to put received data and start
			LinkedBlockingQueue<String> rxQueue = new LinkedBlockingQueue<String>();
			new Thread(new Saver(rxQueue, FileName)).start();

			// Create the socket and start the listener in a new thread
			sSocket = new ServerSocket(port);
			new Thread(new Listener(sSocket, rxQueue, printQueue)).start();

			// Disable some GUI fields when running
			btnBegin.setEnabled(false);
			btnLogFile.setEnabled(false);
			tfPort.setEditable(false);

			// Check for messages to print to GUI window on a timer
			timer = new Timer();
			timer.schedule(new TimerTick(), 250, 250);

		}
		catch (Exception e) {
			printMessage("", false);
			printMessage(e.toString(), true);
			try {
				sSocket.close();
			}
			catch(Exception ex) {

			}
		}
	}//GEN-LAST:event_btnBeginActionPerformed

	// Select the log file
	private void btnLogFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLogFileActionPerformed
		JFileChooser fc = new JFileChooser();
		int rv = fc.showOpenDialog(this);

		try {
			if(rv == JFileChooser.APPROVE_OPTION) {
				File file = fc.getSelectedFile();
				tfLogFile.setText(file.getPath());
				FileName = file.getPath();

				// If file does not exist, put header in first line
				long i = file.length();
				if(i == 0) {
					FileWriter fstream = new FileWriter(FileName, true);
					BufferedWriter out = new BufferedWriter(fstream);
					out.write("EUI,TimeStamp,Temperature,Humidity\n");
					out.close();
				}
			}
		}
		catch(Exception e) {

		}
	}//GEN-LAST:event_btnLogFileActionPerformed

	// Printing of messages to GUI window is handled in a timer
	// Print data is retrieved from the printQueue (LinkedBlockingQueue), this allows other threads
	// to write data to the GUI window
	private class TimerTick extends TimerTask {

		@Override
		public void run() {
			try {
				String printMsg = printQueue.poll();
				if(printMsg != null) {
					printMessage(printMsg, true);
				}
			}
			catch(Exception e) {

			}
		}
	}

	private void printMessage(String msg, boolean TimeStamp) {
		String output = "";
		if(TimeStamp == true) {
			Date now = new Date();
			SimpleDateFormat formatter = new SimpleDateFormat("yy.MM.dd_h:mm.ss ");
			output = formatter.format(now);
		}
		message.append(output + msg + '\n');
/*
		if(FileName != null) {
			try {
				FileWriter fstream = new FileWriter(tfLogFile.getText(), true);
				BufferedWriter out = new BufferedWriter(fstream);
				out.write(output + msg + '\n');
				out.close();
			}
			catch (Exception e) {
				printMessage("File Writing Exception", true);
//				e.printStackTrace();
			}
		}
*/
	}

	public static String toIPAddrString(int ipa)
{
   StringBuilder b = new StringBuilder();
   b.append(Integer.toString(0x000000ff & (ipa >> 24)));
   b.append(".");
   b.append(Integer.toString(0x000000ff & (ipa >> 16)));
   b.append(".");
   b.append(Integer.toString(0x000000ff & (ipa >> 8)));
   b.append(".");
   b.append(Integer.toString(0x000000ff & (ipa)));
   return b.toString();
}
	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		/* Set the Nimbus look and feel */
		//<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
		 * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
		 */
		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException ex) {
			java.util.logging.Logger.getLogger(Post_Server.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (InstantiationException ex) {
			java.util.logging.Logger.getLogger(Post_Server.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (IllegalAccessException ex) {
			java.util.logging.Logger.getLogger(Post_Server.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(Post_Server.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		//</editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable() {

			@Override
			public void run() {
				new Post_Server().setVisible(true);
			}
		});
	}
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBegin;
    private javax.swing.JButton btnLogFile;
    private javax.swing.JButton btnQuit;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblLogFile;
    private javax.swing.JLabel lblPort;
    private javax.swing.JLabel lblTitle;
    private javax.swing.JTextArea message;
    private javax.swing.JTextField tfLogFile;
    private javax.swing.JTextField tfPort;
    // End of variables declaration//GEN-END:variables
}
